%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018-2024  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Write_CSV(CID_DISTR_LOAD_FIELD, PRESSURE_FIELD, Load, Work_Directory, Date_String)

global ErrCode;

fprintf (1, 'Создание .csv файла с полем нагрузок...              ');

File_name = ['Aero_Load_' Modify_Symbols(Date_String)];
File_path = [Work_Directory '\' File_name '.csv'];

Fout = fopen(File_path, 'wt');

if (Fout < 0)
    fprintf (1, '\nОшибка функции Write_CSV: не удалось открыть для записи файл [%s] !\n', File_path);
    ErrCode = -1;
    return;
end

switch Load.Distributed_Load_Mode
    
    case 'CID_DISTR_LOAD'
        
        N_Records = size(CID_DISTR_LOAD_FIELD,1);
        
        CID_DISTR_LOAD_FIELD = sortrows(CID_DISTR_LOAD_FIELD,1);
        
        for i=1:N_Records
            fprintf(Fout, 'Elem %i, <%.10e, %.10e, %.10e>\n', CID_DISTR_LOAD_FIELD(i,1), CID_DISTR_LOAD_FIELD(i,2), CID_DISTR_LOAD_FIELD(i,3), CID_DISTR_LOAD_FIELD(i,4));
        end
        
    case 'PRESSURE'
        
        N_Records = size(PRESSURE_FIELD,1);
        
        PRESSURE_FIELD = sortrows(PRESSURE_FIELD,1);
        
        for i=1:N_Records
            fprintf(Fout, 'Elem %i, %.10e\n', PRESSURE_FIELD(i,1), PRESSURE_FIELD(i,2));
        end
    
end

fclose(Fout);

fprintf (1, 'OK!\n');

fprintf (1, '\n    Экспортировано записей: %i\n', N_Records);
fprintf (1, '\n    Файл [%s.csv] создан успешно!\n', File_name);
